;----------------------------------------------------------------------
;
; 			       1ms 'ISA' Delay
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	API Routines:
;
;	- ISA_Delay
;	- ISA_DelayForIO
;
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc

	.386p

	PUBLIC	isaDelay
	PUBLIC	isaDelayForIO

codeSegment SEGMENT

;---------------------------------------------------------------------------
;	isaDelay
;
;	Entry:
;		ecx = Duration in units of 1ms
;	Exit:
;		None
;
DefProc isaDelay

	jecxz	isaDelayExit

	push	eax
	push	ecx
	push	edx

	mov	eax, 15
	mul	ecx
	mov	ecx, eax

isaDelaySync:
	in	al, 61h
	test	al, 00010000b
	jz	isaDelaySync

isaDelayWait:
	in	al, 61h
	test	al, 00010000b
	jnz	isaDelayWait

	dec	ecx
	jnz	isaDelaySync

	pop	edx
	pop	ecx
	pop	eax

isaDelayExit:
	ret

EndProc isaDelay

;---------------------------------------------------------------------------
;	isaDelayForIO
;
;	Entry:
;		None
;	Exit:
;		None
;
DefProc isaDelayForIO

	out	0EBh, al
	out	0EBh, al
	out	0EBh, al
	ret

EndProc isaDelayForIO

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END

