;---------------------------------------------------------------------------
;
; 		   Miscelenous 'Legacy PC Chip' Support
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	This driver includes support for the following ISA PC AT 
;	compatibility chips and standard features:
;
;	- DMA (8237 Direct Memory Access Controller)
;	- PIC (8259 Programmable Intrerrupt Controller)
;	- PIT (8254 Programmable Interval Timer)
;	- KBC (8042 Keyboard Controller)
;	- RTC (Real-Time Clock)
;
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc
	INCLUDE	kernel.api
	INCLUDE	isa.api

	.386p

codeSegment SEGMENT

	EXTERN	isaDelay:NEAR
	EXTERN	isaDelayForIO:NEAR
	EXTERN	speakerOn:NEAR
	EXTERN	speakerOff:NEAR

	EXTERN	dmaMaskChannel:NEAR
	EXTERN	dmaUnMaskChannel:NEAR
	EXTERN	dmaStartTransfer:NEAR
	EXTERN	dmaClearTransfer:NEAR

	EXTERN	picGetBase:NEAR
	EXTERN	picSetBase:NEAR
	EXTERN	picMask:NEAR
	EXTERN	picUnMask:NEAR
	EXTERN	picEOI:NEAR

	EXTERN	pitProgramChannel:NEAR

	EXTERN	kbcSendCommand:NEAR
	EXTERN	kbcSendData:NEAR
	EXTERN	kbcReceiveData:NEAR
	EXTERN	kbcSendToKbd:NEAR
	EXTERN	kbcReceiveFromKbd:NEAR
	EXTERN	kbcSendToAux:NEAR
	EXTERN	kbcReceiveFromAux:NEAR

	EXTERN	rtcRead:NEAR
	EXTERN	rtcWrite:NEAR
	EXTERN	rtcGetTime:NEAR
	EXTERN	rtcSetTime:NEAR
	EXTERN	rtcGetDate:NEAR
	EXTERN	rtcSetDate:NEAR
	EXTERN	rtcGetAlarm:NEAR
	EXTERN	rtcSetAlarm:NEAR

;---------------------------------------------------------------------------
;	isaGetVersion - 
;
;	Entry:
;		None
;	Exit:
;		eax = version ID
;
isaGetVersion PROC NEAR

	mov	eax, 00000100h
	clc
	ret

isaGetVersion ENDP

;---------------------------------------------------------------------------
;	mainEntryPoint - ISA.SYS entry point
;
;	Entry (Stack):
;
;		DWORD = return address
;
;	Entry (Registers):
;
;		ebx = our memory block base -- "module handle"
;		ecx = our memory block size
;
mainEntryPoint PROC NEAR

	mov	esi, OFFSET apiServiceTbl
	APIcall	KERNEL_ApiRegister

	clc
	ret

mainEntryPoint ENDP

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

;---------------------------------------------------------------------------
; ISA.SYS API Service Table
;---------------------------------------------------------------------------

apiServiceTbl	LABEL	DWORD
	API_TABLE	<apiServiceDef, (apiServiceEnd-apiServiceDef)/8>
apiServiceDef	LABEL	DWORD
	API_ENTRY	<ISA_GetVersion,		isaGetVersion>
	API_ENTRY	<ISA_Delay,			isaDelay>
	API_ENTRY	<ISA_DelayForIO,		isaDelayForIO>
	API_ENTRY	<ISA_SpeakerOn,			speakerOn>
	API_ENTRY	<ISA_SpeakerOff,		speakerOff>
	API_ENTRY	<ISA_DMA_MaskChannel,		dmaMaskChannel>
	API_ENTRY	<ISA_DMA_UnMaskChannel,		dmaUnMaskChannel>
	API_ENTRY	<ISA_DMA_StartTransfer,		dmaStartTransfer>
	API_ENTRY	<ISA_DMA_ClearTransfer,		dmaClearTransfer>
	API_ENTRY	<ISA_PIC_GetBase,		picGetBase>
	API_ENTRY	<ISA_PIC_SetBase,		picSetBase>
	API_ENTRY	<ISA_PIC_Mask,			picMask	>
	API_ENTRY	<ISA_PIC_UnMask,		picUnMask>
	API_ENTRY	<ISA_PIC_EOI,			picEOI>
	API_ENTRY	<ISA_PIT_ProgramChannel,	pitProgramChannel>
	API_ENTRY	<ISA_KBC_SendCommand,		kbcSendCommand>
	API_ENTRY	<ISA_KBC_SendData,		kbcSendData>
	API_ENTRY	<ISA_KBC_ReceiveData,		kbcReceiveData>
	API_ENTRY	<ISA_KBC_SendToKbd,		kbcSendToKbd>
	API_ENTRY	<ISA_KBC_ReceiveFromKbd,	kbcReceiveFromKbd>
	API_ENTRY	<ISA_KBC_SendToAux,		kbcSendToAux>
	API_ENTRY	<ISA_KBC_ReceiveFromAux,	kbcReceiveFromAux>
	API_ENTRY	<ISA_RTC_Read,			rtcRead>
	API_ENTRY	<ISA_RTC_Write,			rtcWrite>
	API_ENTRY	<ISA_RTC_GetTime,		rtcGetTime>
	API_ENTRY	<ISA_RTC_SetTime,		rtcSetTime>
	API_ENTRY	<ISA_RTC_GetDate,		rtcGetDate>
	API_ENTRY	<ISA_RTC_SetDate,		rtcSetDate>
	API_ENTRY	<ISA_RTC_GetAlarm,		rtcGetAlarm>
	API_ENTRY	<ISA_RTC_SetAlarm,		rtcSetAlarm>
apiServiceEnd	LABEL	DWORD

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END	mainEntryPoint
