;---------------------------------------------------------------------------
;
; 			  8259 PIC Support Routines
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	API Routines:
;
;	- ISA_PIC_GetBase
;	- ISA_PIC_SetBase
;	- ISA_PIC_Mask
;	- ISA_PIC_UnMask
;	- ISA_PIC_EOI
;
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc
	INCLUDE	kernel.api

	.386p

	PUBLIC	picGetBase
	PUBLIC	picSetBase
	PUBLIC	picMask
	PUBLIC	picUnMask
	PUBLIC	picEOI

codeSegment SEGMENT

;---------------------------------------------------------------------------
;	picGetBase
;
;	Entry:
;		None
;	Exit:
;		bl = 1st 8259 IRQ base
;		bh = 2nd 8259 IRQ base
;
DefProc picGetBase

	APIjmp	KERNEL_IrqGetBase

EndProc picGetBase

;---------------------------------------------------------------------------
;	picSetBase
;
;	Entry:
;		bl = 1st 8259 IRQ base
;		bh = 2nd 8259 IRQ base
;	Exit:
;		None
;
DefProc picSetBase

	APIjmp	KERNEL_IrqSetBase

EndProc picSetBase

;---------------------------------------------------------------------------
;	picMask - physically mask the specified 8259 IRQ
;
;	Entry:
;		al = IRQ #
;	Exit:
;		None
;
DefProc picMask

	APIjmp	KERNEL_IrqMask

EndProc picMask

;---------------------------------------------------------------------------
;	picUnMask - physically unmask the specified 8259 IRQ
;
;	Entry:
;		al = IRQ #
;	Exit:
;		None
;
DefProc picUnMask

	APIjmp	KERNEL_IrqUnMask

EndProc picUnMask

;---------------------------------------------------------------------------
;	picEOI - send non-specific EOI
;
;	Entry:
;		al = IRQ #
;	Exit:
;		None
;
DefProc picEOI

	APIjmp	KERNEL_IrqEOI

EndProc picEOI

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END

