;---------------------------------------------------------------------------
;
; 		     32-bit PM GDT and Interface Routines
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;
;	API Routines:
;
;	- KERNEL_GdtGetEntry
;	- KERNEL_GdtSetEntry
;
;---------------------------------------------------------------------------

	INCLUDE	std.inc
	INCLUDE	stdgroup.inc

	.386p

	; Exports

	PUBLIC	gdtGetEntry
	PUBLIC	gdtSetEntry

codeSegment SEGMENT

;---------------------------------------------------------------------------
;	gdtGetEntry
;
;	Entry:
;		eax = GDT selector
;	Exit:
;		ebx = GDT descriptor base
;		ecx = GDT descriptor Entry
;		edx = GDT descriptor type
;
DefProc gdtGetEntry

	pushfd
	push	esi

	cli

;	push	esi
;	push	esi
;
;	sgdt	[esp][2]
;
;	pop	esi
;	pop	esi
;
;	add	esi, eax

	lea	esi, kernelGDTDef[eax]

	mov	bl, [esi].gdtBase_16_23
	mov	bh, [esi].gdtBase_24_31
	shl	ebx, 16
	mov	bx, [esi].gdtBase_00_15

	push	WORD PTR [esi].gdtMisc
	push	WORD PTR [esi].gdtLimit
	pop	ecx

	and	ecx, 008FFFFFh
	test	ecx, 00800000h
	jz	gdtGetEntrySkip

	shl	ecx, 12
	or	ecx, 00000FFFh

gdtGetEntrySkip:
	movzx	edx, [esi].gdtType

gdtGetEntryExit:
	pop	esi
	popfd
	ret

EndProc gdtGetEntry

;---------------------------------------------------------------------------
;	gdtSetEntry
;
;	Entry:
;		eax = GDT selector
;		ebx = GDT descriptor base
;		ecx = GDT descriptor limit
;		edx = GDT descriptor type
;	Exit:
;		None
;
DefProc gdtSetEntry

	pushfd
	push	ebx
	push	ecx
	push	esi

	cli

;	push	esi
;	push	esi
;
;	sgdt	[esp][2]
;
;	pop	esi
;	pop	esi
;
;	add	esi, eax

	lea	esi, kernelGDTDef[eax]

	mov	[esi].gdtBase_00_15, bx
	shr	ebx, 16
	mov	[esi].gdtBase_16_23, bl
	mov	[esi].gdtBase_24_31, bh

	cmp	ecx, 000FFFFFh
	jna	gdtSetEntryTiny

	shr	ecx, 12
	or	ecx, 00800000h

gdtSetEntryTiny:
	mov	[esi].gdtLimit, cx
	shr	ecx, 16
	and	cl, 10001111b

	and	[esi].gdtMisc, 01110000b
	or	[esi].gdtMisc, cl

	mov	[esi].gdtType, dl

	pop	esi
	pop	ecx
	pop	ebx
	popfd
	ret

EndProc gdtSetEntry

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

	PUBLIC	kernelGDTPtr
	PUBLIC	kernelGDTDef
	PUBLIC	kernelGDTEnd

dataSegment SEGMENT

;---------------------------------------------------------------------------
; GDT register
;---------------------------------------------------------------------------

kernelGDTPtr	LABEL	FWORD
	DW	kernelGDTEnd-kernelGDTDef-1
	DD	kernelGDTDef
	DW	NULL

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

;---------------------------------------------------------------------------
; GDT -- Global Descriptor Table
;---------------------------------------------------------------------------

kernelGDTDef	LABEL	DWORD
	GDT	256 DUP (<>)
kernelGDTEnd	LABEL	DWORD

bssSegment ENDS

	END
