;=-------------------------------------------------------------------------=
;
;		Keyboard Layout: NO - Norway (Norwegian)
;
;     Copyright (c) 1999-2000 by Thomas Kjoernes, all rights reserved.
;
;=-------------------------------------------------------------------------=

	INCLUDE	std.inc
	INCLUDE	stdgroup.inc
	INCLUDE	keyboard.inc

	; Publics

	PUBLIC	kbLayoutNO

dataSegment SEGMENT

kbLayoutNO	KB_LAYOUT <"NO", NULL, noMain, noAltGr, noExtended>

; Allow FFh hex without leading zero for neatness.

FFh		EQU	0FFh

		;	+--------------------- 0=Normal
		;	                      1=Normal, Caps-Lock Sensitive
		;	                      2=Zeroed, ASCII=00h
		;	                      3=Numpad
		;	   +----------------- Normal
		;	       +------------ Shift
		;	           +------- Ctrl
		;	               +-- Alt
		;	               

noMain		LABEL	BYTE
	
		DB	0, FFh, FFh, FFh, FFh	; 00 - Error
		DB	0, 1Bh, 1Bh, 1Bh, FFh	; 01 - Escape
		DB	0, "1", "!", FFh, 78h	; 02 - 1
		DB	0, "2", '"', FFh, 79h	; 03 - 2
		DB	0, "3", "#", FFh, 7Ah	; 04 - 3
		DB	0, "4", "", FFh, 7Bh	; 05 - 4
		DB	0, "5", "%", FFh, 7Ch	; 06 - 5
		DB	0, "6", "&", FFh, 7Dh	; 07 - 6
		DB	0, "7", "/", FFh, 7Eh	; 08 - 7
		DB	0, "8", "(", FFh, 7Fh	; 09 - 8
		DB	0, "9", ")", FFh, 80h	; 0A - 9
		DB	0, "0", "=", FFh, 81h	; 0B - 0
		DB	0, "+", "?", FFh, 82h	; 0C - Minus
		DB	0, "\", FFh, FFh, FFh	; 0D - Backslash
		DB	0, 08h, 08h, FFh, FFh	; 0E - Backspace
		DB	0, 09h, 00h, FFh, FFh	; 0F - Tab
		DB	1, "q", "Q", 11h, 10h	; 10 - Q
		DB	1, "w", "W", 17h, 11h	; 11 - W
		DB	1, "e", "E", 05h, 12h	; 12 - E
		DB	1, "r", "R", 12h, 13h	; 13 - R
		DB	1, "t", "T", 14h, 14h	; 14 - T
		DB	1, "y", "Y", 19h, 15h	; 15 - Y
		DB	1, "u", "U", 15h, 16h	; 16 - U
		DB	1, "i", "I", 09h, 17h	; 17 - I
		DB	1, "o", "O", 0Fh, 18h	; 18 - O
		DB	1, "p", "P", 10h, 19h	; 19 - P
		DB	1, "", "", 1Bh, FFh	; 1A - 
		DB	0, FFh, FFh, FFh, FFh	; 1B - DeadKey
		DB	0, 0Dh, 0Dh, 0Ah, FFh	; 1C - Enter
		DB	0, FFh, FFh, FFh, FFh	; 1D - Ctrl
		DB	1, "a", "A", 01h, 1Eh	; 1E - A
		DB	1, "s", "S", 13h, 1Fh	; 1F - S
		DB	1, "d", "D", 04h, 20h	; 20 - D
		DB	1, "f", "F", 06h, 21h	; 21 - F
		DB	1, "g", "G", 07h, 22h	; 22 - G
		DB	1, "h", "H", 08h, 23h	; 23 - H
		DB	1, "j", "J", 0Ah, 24h	; 24 - J
		DB	1, "k", "K", 0Bh, 25h	; 25 - K
		DB	1, "l", "L", 0Ch, 26h	; 26 - L
		DB	1, "", "", FFh, FFh	; 27 - 
		DB	1, "", "", FFh, FFh	; 28 - 
		DB	0, "|", "", FFh, FFh	; 29 - Pipe
		DB	0, FFh, FFh, FFh, FFh	; 2A - Shift
		DB	0, "'", "*", 1Ch, FFh	; 2B - Apostrophe
		DB	1, "z", "Z", 1Ah, 2Ch	; 2C - Z
		DB	1, "x", "X", 18h, 2Dh	; 2D - X
		DB	1, "c", "C", 03h, 2Eh	; 2E - C
		DB	1, "v", "V", 16h, 2Fh	; 2F - V
		DB	1, "b", "B", 02h, 30h	; 30 - B
		DB	1, "n", "N", 0Eh, 31h	; 31 - N
		DB	1, "m", "M", 0Dh, 32h	; 32 - M
		DB	0, ",", ";", FFh, FFh	; 33 - Comma
		DB	0, ".", ":", FFh, FFh	; 34 - Period
		DB	0, "-", "_", FFh, FFh	; 35 - Minus
		DB	0, FFh, FFh, FFh, FFh	; 36 - Shift
		DB	0, "*", "*", FFh, FFh	; 37 - Asterisks
		DB	0, FFh, FFh, FFh, FFh	; 38 - Alt
		DB	0, " ", " ", FFh, FFh	; 39 - Space
		DB	0, FFh, FFh, FFh, FFh	; 3A - Caps
		DB	2, 3Bh, 54h, 5Eh, 68h	; 3B - F1
		DB	2, 3Ch, 55h, 5Fh, 69h	; 3C - F2
		DB	2, 3Dh, 56h, 60h, 6Ah	; 3D - F3
		DB	2, 3Eh, 57h, 61h, 6Bh	; 3E - F4
		DB	2, 3Fh, 58h, 62h, 6Ch	; 3F - F5
		DB	2, 40h, 59h, 63h, 6Dh	; 40 - F6
		DB	2, 41h, 5Ah, 64h, 6Eh	; 41 - F7
		DB	2, 42h, 5Bh, 65h, 6Fh	; 42 - F8
		DB	2, 43h, 5Ch, 66h, 70h	; 43 - F9
		DB	2, 44h, 5Dh, 67h, 71h	; 44 - F10
		DB	0, FFh, FFh, FFh, FFh	; 45 - Num
		DB	0, FFh, FFh, FFh, FFh	; 46 - Scroll
		DB	3, 00h, "7", FFh, FFh	; 47 - 7 Home
		DB	3, 00h, "8", FFh, FFh	; 48 - 8 Up
		DB	3, 00h, "9", FFh, FFh	; 49 - 9 PgUp
		DB	0, "-", "-", FFh, FFh	; 4A - Minus
		DB	3, 00h, "4", FFh, FFh	; 4B - 4 Left
		DB	3, 00h, "5", FFh, FFh	; 4C - 5
		DB	3, 00h, "6", FFh, FFh	; 4D - 6 Right
		DB	0, "+", "+", FFh, FFh	; 4E - Plus
		DB	3, 00h, "1", FFh, FFh	; 4F - 1 End
		DB	3, 00h, "2", FFh, FFh	; 50 - 2 Down
		DB	3, 00h, "3", FFh, FFh	; 51 - 3 PgDn
		DB	3, 00h, "0", FFh, FFh	; 52 - Insert
		DB	3, 00h, ",", FFh, FFh	; 53 - Delete
		DB	0, FFh, FFh, FFh, FFh	; 54 - SysReq
		DB	0, FFh, FFh, FFh, FFh	; 55 
		DB	0, "<", ">", FFh, FFh	; 56 - Tags
		DB	2, 85h, 87h, 89h, 8Bh	; 57 - F11
		DB	2, 86h, 88h, 8Ah, 8Ch	; 58 - F12
		DB	0, FFh, FFh, FFh, FFh	; 59
		DB	0, FFh, FFh, FFh, FFh	; 5A
		DB	0, FFh, FFh, FFh, FFh	; 5B - LWin
		DB	0, FFh, FFh, FFh, FFh	; 5C - RWin
		DB	2, 98h, 99h, 9Ah, 9Bh	; 5D - Menu
		DB	0, FFh, FFh, FFh, FFh	; 5E
		DB	0, FFh, FFh, FFh, FFh	; 5F

		;	+--------------------- Scancode
		;	     +--------------- ASCII
		;	     

noAltGr		LABEL	BYTE
		DB	03h, "@"
		DB	04h, ""
		DB	05h, "$"
		DB	06h, ""
		DB	07h, ""
		DB	08h, "{"
		DB	09h, "["
		DB	0Ah, "]"
		DB	0Bh, "}"
		DB	12h, ""
		DB	1Bh, "~"
		DB	4Bh, ""
		DB	4Dh, ""
		DB	13h, ""
		DB	FFh

		;	+--------------------- Scancode
		;	     +--------------- ASCII
		;	     

noExtended	LABEL	BYTE
		DB	35h, "/"
		DB	48h, 24
		DB	50h, 25
		DB	4Bh, 27
		DB	4Dh, 26
		DB	FFh

		;	+--------------------- Scancode
		;	     +--------------- ASCII
		;	     

noDeadKeys	LABEL	BYTE
		DB	00h, " ", ""
		DB	00h, " ", "^"
		DB	00h, " ", "~"
		DB	00h, " ", "`"
		DB	00h, " ", ""
		DB	FFh

		DB	00h, "a", ""
		DB	00h, "e", ""
		DB	00h, "i", ""
		DB	00h, "o", ""
		DB	00h, "u", ""
		DB	00h, "y", ""
		DB	FFh

		DB	00h, "a", ""
		DB	00h, "e", ""
		DB	00h, "i", ""
		DB	00h, "o", ""
		DB	00h, "u", ""
		DB	FFh

		DB	00h, "a", ""
		DB	00h, "n", ""
		DB	00h, "o", ""
		DB	FFh

		DB	00h, "a", ""
		DB	00h, "e", ""
		DB	00h, "i", ""
		DB	00h, "o", ""
		DB	00h, "u", ""
		DB	FFh

		DB	00h, "a", ""
		DB	00h, "e", ""
		DB	00h, "i", ""
		DB	00h, "o", ""
		DB	00h, "u", ""
		DB	00h, "y", ""
		DB	FFh

		DB	00h, "A", ""
		DB	00h, "E", ""
		DB	00h, "I", ""
		DB	00h, "O", ""
		DB	00h, "U", ""
		DB	FFh

		DB	00h, "A", ""
		DB	00h, "E", ""
		DB	00h, "I", ""
		DB	00h, "O", ""
		DB	00h, "U", ""
		DB	FFh

		DB	00h, "A", ""
		DB	00h, "N", ""
		DB	00h, "O", ""
		DB	FFh

		DB	00h, "A", ""
		DB	00h, "E", ""
		DB	00h, "I", ""
		DB	00h, "O", ""
		DB	00h, "U", ""
		DB	FFh

		DB	00h, "A", ""
		DB	00h, "E", ""
		DB	00h, "I", ""
		DB	00h, "O", ""
		DB	00h, "U", ""
		DB	00h, "Y", ""
		DB	FFh

dataSegment ENDS

	END
