;---------------------------------------------------------------------------
;
;			32-bit Virtual Memory Manager
;
;     Copyright (c) 1999-2001 by Thomas Kjoernes, all rights reserved.
;
;---------------------------------------------------------------------------

	INCLUDE std.inc
	INCLUDE stdgroup.inc
	INCLUDE	kernel.api
	INCLUDE vmm.api

	.386p

	; Publics

codeSegment SEGMENT

	; Externs

;---------------------------------------------------------------------------
;	mainEntryPoint - VMM.SYS entry point
;
;	Entry (Stack):
;
;		DWORD = return address
;
;	Entry (Registers):
;
;		ebx = our memory block base -- "module handle"
;		ecx = our memory block size
;
DefProc mainEntryPoint

	mov	esi, OFFSET apiServiceTbl
	APIcall	KERNEL_ApiRegister

	clc
	ret

EndProc mainEntryPoint

;---------------------------------------------------------------------------
;	vmmGetVersion - 
;
;	Entry:
;		None
;	Exit:
;		eax = version ID
;
DefProc vmmGetVersion

	mov	eax, 00000100h
	clc
	ret

EndProc vmmGetVersion

codeSegment ENDS

;---------------------------------------------------------------------------
; Data
;---------------------------------------------------------------------------

dataSegment SEGMENT

;---------------------------------------------------------------------------
; VMM.SYS API Service Table
;---------------------------------------------------------------------------

apiServiceTbl	LABEL	DWORD
	API_TABLE	<apiServiceDef, (apiServiceEnd-apiServiceDef)/8>
apiServiceDef	LABEL	DWORD
	API_ENTRY	<VMM_GetVersion,	vmmGetVersion>
apiServiceEnd	LABEL	DWORD

dataSegment ENDS

;---------------------------------------------------------------------------
; BSS Data
;---------------------------------------------------------------------------

bssSegment SEGMENT

bssSegment ENDS

	END	mainEntryPoint
